<?php
class ProjectExtract{
	public $file = null;
	public $file_path = null;
	public $file_name = null;
	public $file_ext = null;
	public $file_size = null;
	public $total_file_size = null;
	public $file_line = 0;
	public $total_lines = 0;
	public $file_lines = 0;
	public $file_queue = array();
	public $file_total = 0;
	public $svopts = array();

	public $userinfo = array();
	public $search = array();
	public $searchf = array();
	public $console = array();
	public $server = array();
	public $fileinfo = array();

	public function scan_directory(){
		if(file_exists(LOG_DIR)){
			$dir = scandir(LOG_DIR);
			for($i=2; $i <= count($dir)-1; $i++){
				$this->file_path = LOG_DIR.'/'.$dir[$i];
				$this->file_name = basename($this->file_path);
				$this->file_ext = pathinfo($this->file_name, PATHINFO_EXTENSION);
				$this->total_file_size = $this->total_file_size + filesize($this->file_path);
				if($this->file_ext == VALID_EXT){
					$this->file_queue[] = $this->file_name;
					$this->file_total++;
				}
			}
		}
	}
	public function extract($type, $string=null, $cs=false, $svopts=null){
		if($type == TYPE_USER){
			$queue_count = count($this->file_queue)-1;
			for($i=0;$i<=$queue_count;++$i){
				$this->file_path = LOG_DIR."/".$this->file_queue[$i];
				$this->file_name = basename($this->file_path);
				$this->file_size = filesize($this->file_path);
				$this->file = fopen($this->file_path, "r");
				while(($this->file_line = fgets($this->file)) !== false){
					$this->file_lines++;
					if(preg_match("/[Uu][Ss][Gg][Nn]:/", $this->file_line)){
						if(!in_array($this->file_line, $this->userinfo)){
							$this->file_line = self::filter($this->file_line);
							$this->userinfo[] = $this->file_line;
							$this->fileinfo[] = $this->file_name.":".$this->file_lines;
							if(SLOW_DOWN_M8 !== 0){sleep(SLOW_DOWN_M8);}
						}
					}
				}
			$this->total_lines = $this->total_lines + $this->file_lines;
			$this->file_lines = 0;
			}
		}elseif($type == TYPE_SEARCH){
			$queue_count = (count($this->file_queue)-1);
			for($i=0;$i<=$queue_count;$i++) {
				$this->file_path = LOG_DIR."/".$this->file_queue[$i];
				$this->file_name = basename($this->file_path);
				$this->file_size = filesize($this->file_path);
				$this->file = fopen($this->file_path, "r");
				while(($this->file_line = fgets($this->file)) !== false){
					$this->file_lines++;
					if(preg_match("/\b".$string."\b/", $this->file_line)){
						$this->file_line = self::filter($this->file_line);
						if(!in_array($this->file_line, $this->search)){
							$this->searchf[] = "[".$this->file_name.":".$this->file_lines."] ".$this->file_line;
							$highlight = substr($this->file_line, strpos($this->file_line, $string), strlen($string));
							$beforeHighlight = substr($this->file_line, 0, strpos($this->file_line, $string));
							$afterHighlight = substr($this->file_line, strpos($this->file_line, $string) + strlen($string));
							$this->file_line = $beforeHighlight."<span class=\"highlight\">".$highlight."</span>".$afterHighlight;
							$this->search[] = $this->file_line;
							$this->fileinfo[] = array("file"=>$this->file_name,"line"=>$this->file_lines);
							if(SLOW_DOWN_M8 !== 0){sleep(SLOW_DOWN_M8);}
						}
					}
				}
			$this->total_lines = $this->total_lines + $this->file_lines;
			$this->file_lines = 0;
			}
		}elseif($type == TYPE_SERVER){
			/**
			* Server Log Extraction!
			* Yeah, this one's a bit different. Here's to how it works.
			* The first thing it extracts is the extraction date/time file name and server version from the first line.
			* Next, depending on the user's chosen requests it extracts a bunch of stuff. Here's everything so far;
			* 
			* JOIN: This extracts the client's (user's) data upon him joining. His name, Ip, usgn & OS. If you want,
			* it even logs it into sud.pe. A supreme server user information database.
			*
			* LUA ERROR: You know what this is. These errors are kept from spamming you over and over again therefore,
			* we've ensured that it only outputs the error (which appears throughout the logs) ONCE.
			*
			* ERROR: You know what this is as well. These errors are kept from spamming you over and over again therefore,
			* we've ensured that it only outputs the error (which appears throughout the logs) ONCE.
			*
			* NET: Resource File Transfer Errors. This shows which files give errors in transfering.
			* To make sure it doesn't spam you with the same stuff over and over again in the console, we've 
			* made it sure that it only outputs the transfer files which give errors ONCE.
			*
			* COUNT STATS: Removed
			*/
			$this->svopts = $svopts;
			$queue_count = (count($this->file_queue)-1);
			for($i=0;$i<=$queue_count;$i++) {
				$this->file_path = LOG_DIR."/".$this->file_queue[$i];
				$this->file_name = basename($this->file_path);
				$this->file_size = filesize($this->file_path);
				$this->file = fopen($this->file_path, "r");
				while(($this->file_line = fgets($this->file)) !== false){
					$this->file_lines++;
					$this->file_line = self::filter($this->file_line);
					foreach ($this->svopts as $key => $value){
						if($value == 'join'){
							if(preg_match("/is using IP/", $this->file_line) && preg_match("/and U.S.G.N. ID #/", $this->file_line)){
								$this->server['join'][] = $this->file_line;
								$this->fileinfo[] = array("file"=>$this->file_name,"line"=>$this->file_lines);
							}
						}
						if($value == 'lua-errors'){
							if(preg_match("/^LUA ERROR:/", $this->file_line)){
								$this->server['lua-error'][] = $this->file_line;
								$this->fileinfo[] = array("file"=>$this->file_name,"line"=>$this->file_lines);
							}
						}
						if($value == 'errors'){
							if(preg_match("/^ERROR:/", $this->file_line)){
								$this->server['errors'][] = $this->file_line;
								$this->fileinfo[] = array("file"=>$this->file_name,"line"=>$this->file_lines);
							}
						}
						if($value == 'net-errors'){
							if(preg_match("/^NET:/", $this->file_line)){
								$this->server['net-errors'][] = $this->file_line;
								$this->fileinfo[] = array("file"=>$this->file_name,"line"=>$this->file_lines);
							}
						}
						if($value == 'count-stats'){
							if(preg_match("/^stats generated in/", $this->file_line)){
								$this->server['countstats'][] = $this->file_line;
							}
						}
					}
				}
				$this->total_lines = $this->total_lines + $this->file_lines;
				$this->file_lines = 0;
			}
		}else{/*Invalid Error*/}
	}
	public function save($query=null,$arr,$type){
		switch ($type) {
			case TYPE_USER:
				//none, because type user extraction already has user database
				break;
			case TYPE_SEARCH:
				$f = fopen(SEARCH_LOG_PATH,OVERWRITE_EL);
				if(!is_null($query)){ fwrite($f, "----- Query: ".$query." -----\n"); }				
				for($i=0;$i<=count($arr)-1;$i++){
					fwrite($f, trim($arr[$i])."\n");
				}
				fclose($f);
				break;
			case TYPE_SERVER:
				//Not added due to extensive CPU/memory overload while extraction
				break;
		}
	}
	protected function filter($string){
		$string = substr($string, 11);
		if(preg_match("/^#[0-9]{1}/", $string) || preg_match("/^#[0-9]{2}/", $string)){
			$string = substr($string, 3);
		}
		if(preg_match("/^:\s/", $string)){
			$string = substr($string, 2);
		}
		$string = trim($string);
		return $string;
	}
	protected function file_details($file_path){
		return "\"".$file_path."\" (".filesize($file).")";
	}
	protected function logFile($path, $text=null){
		if(!file_exists($path)){
			$f = fopen($path, "w+");
			if($f){
				fclose($f);
			}
		}
		if(!is_null($text)){
			if(is_string($text)){
				$f = fopen($path, "a+");
				fwrite($f, $text."\n");
				fclose($f);
			}
		}
	}
}
?>