<?php

class utils{
	protected $log = null;
	protected $new_arr = array();
	public function updateStat($stat_type, $new_value){
		$cfg = new Config;
		$cfg->unpack(STATS_FILE_PATH);
		$this->log = new parse;
		$this->log->log(DEBUG_LOG, "Unpacking Statistic File");
		$this->new_arr["ud-registers"] = $cfg->config["ud-registers"];
		$this->new_arr["sud-registers"] = $cfg->config["sud-registers"];
		$this->new_arr["user-info-extracts"] = $cfg->config["user-info-extracts"];
		$this->new_arr["search-extracts"] = $cfg->config["search-extracts"];
		$this->new_arr["server-extracts"] = $cfg->config["server-extracts"];
		$this->new_arr["console-extracts"] = $cfg->config["console-extracts"];
		switch ($stat_type) {
			case TYPE_UD:
				$this->new_arr["sud-registers"] = $new_value;
				break;
			case TYPE_UD:
				$this->new_arr["ud-registers"] = $new_value;
				break;
			case TYPE_UI:
				$this->new_arr["user-info-extracts"] = $cfg->config["user-info-extracts"] + $new_value;
				break;
			case TYPE_QS:
				$this->new_arr["search-extracts"] = $cfg->config["search-extracts"] + $new_value;
				break;
			case TYPE_S:
				$this->new_arr["server-extracts"] = $cfg->config["server-extracts"] + $new_value;
				break;
			case TYPE_C:
				$this->new_arr["console-extracts"] = $cfg->config["console-extracts"] + $new_value;
				break;
		}
		$cfg->pack(STATS_FILE_PATH, $this->new_arr);
		$this->log->log(DEBUG_LOG, "Packing Statistic File");	
	}
	public function resetStats(){
		$cfg = new Config;
		$cfg->unpack(STATS_FILE_PATH);
		$this->log = new parse;
		$this->log->log(DEBUG_LOG, "Unpacking Statistic File");
		$this->new_arr["ud-registers"] = $cfg->config["ud-registers"];
		$this->new_arr["user-info-extracts"] = 0;
		$this->new_arr["search-extracts"] = 0;
		$this->new_arr["server-extracts"] = 0;
		$this->new_arr["console-extracts"] = 0;
		$cfg->pack(STATS_FILE_PATH, $this->new_arr);
		$this->log->log(DEBUG_LOG, "Packing Statistic File");		
		$this->log->log(DEBUG_LOG, "Stat File Reset");		
	}
	public function smart_data_calc($bytes){
		$kb = 1024;
		$mb = $kb*1024;
		$gb = $mb*1024;
		$tb = $gb*1024;
		if(($bytes>=0)&&($bytes<$kb)){
			return 'Less than 1 kB';
		}elseif(($bytes>=$kb)&&($bytes<$mb)){
			return round($bytes/$kb,2).' kB';
		}elseif(($bytes>=$mb)&&($bytes<$gb)){
			return round($bytes/$mb,2).' mb';
		}elseif(($bytes>=$gb)&&($bytse<$tb)){
			return round($bytes/$gb,2).' gb';
		}elseif($bytes>=$tb){
			return 'Greater than 1TB';
		}else{
			return 'Less than 1 kB';
		}
	}
}

?>